hdu 1026

Ignatius and the Princess I

                                                                            Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                                                                                   Total Submission(s): 18613    Accepted Submission(s): 6005
                                                                                                                                          Special Judge


Problem Description
The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166's room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them, he has to kill them. Here is some rules:

1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).
2.The array is marked with some characters and numbers. We define them like this:
. : The place where Ignatius can walk on.
X : The place is a trap, Ignatius should not walk on it.
n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.

Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position.
 

Input
The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole labyrinth. The input is terminated by the end of file. More details in the Sample Input.
 

Output
For each test case, you should output "God please help our poor hero." if Ignatius can't reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output.
 

Sample Input
 
 
5 6 .XX.1. ..X.2. 2...X. ...XX. XXXXX. 5 6 .XX.1. ..X.2. 2...X. ...XX. XXXXX1 5 6 .XX... ..XX1. 2...X. ...XX. XXXXX.
 

Sample Output
 
 
It takes 13 seconds to reach the target position, let me show you the way. 1s:(0,0)->(1,0) 2s:(1,0)->(1,1) 3s:(1,1)->(2,1) 4s:(2,1)->(2,2) 5s:(2,2)->(2,3) 6s:(2,3)->(1,3) 7s:(1,3)->(1,4) 8s:FIGHT AT (1,4) 9s:FIGHT AT (1,4) 10s:(1,4)->(1,5) 11s:(1,5)->(2,5) 12s:(2,5)->(3,5) 13s:(3,5)->(4,5) FINISH It takes 14 seconds to reach the target position, let me show you the way. 1s:(0,0)->(1,0) 2s:(1,0)->(1,1) 3s:(1,1)->(2,1) 4s:(2,1)->(2,2) 5s:(2,2)->(2,3) 6s:(2,3)->(1,3) 7s:(1,3)->(1,4) 8s:FIGHT AT (1,4) 9s:FIGHT AT (1,4) 10s:(1,4)->(1,5) 11s:(1,5)->(2,5) 12s:(2,5)->(3,5) 13s:(3,5)->(4,5) 14s:FIGHT AT (4,5) FINISH God please help our poor hero. FINISH
 

Author
Ignatius.L
 
     
/*
  一道典型的bfs() 但跟平常的不太一样 因为所走的路上可能要打怪这需要花费时间
  所以不能单纯的直接bfs() 要引入优先队列 走到当前位置时间短的出队
  我的做法是用当前的值跟ans比较不停的更新时间的最小值
  难点在于如何打印路径 用dfs()来打印路径 引入数组path[][]来指向来的路
*/
#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>
#include <algorithm>
#include <string>
#include <cstdlib>
#include <stack>
#include <map>
#include <queue>
using namespace std;
struct node
{int x,y,step;
 node(){}
 node(int _x,int _y,int _step){x=_x,y=_y,step=_step;}
}path[110][110];
const int INF = 1e9;
int dir[4][2]={1,0,-1,0,0,-1,0,1};
char mp[110][110];
int dist[110][110];
int n,m,temp;
int ans=0;
bool check(node a)
{
    if(a.x>=0&&a.x<n&&a.y>=0&&a.y<m) return true;
    return false;
}
void bfs()
{
    queue<node>Q;
    Q.push(node{0,0,0});
    while(!Q.empty())
    {
        node head=Q.front();
        Q.pop();
        if(head.x==n-1&&head.y==m-1) ans=min(ans,head.step);
        for(int i=0;i<4;i++)
        {
            node next;
            next.x=head.x+dir[i][0];
            next.y=head.y+dir[i][1];
            if(check(next)&&mp[next.x][next.y]!='X')
            {
                if(mp[next.x][next.y]=='.')
                {
                    next.step=head.step+1;
                    if(next.step<=ans&&next.step<dist[next.x][next.y])
                    {
                        dist[next.x][next.y]=next.step;
                        path[next.x][next.y].x=head.x;
                        path[next.x][next.y].y=head.y;
                        path[next.x][next.y].step=0;
                        Q.push(next);
                    }
                }
                else if(mp[next.x][next.y]>='0'&&mp[next.x][next.y]<='9')
                {
                    next.step=head.step+1+mp[next.x][next.y]-'0';
                    if(next.step<=ans&&next.step<dist[next.x][next.y])
                    {
                        dist[next.x][next.y]=next.step;
                        path[next.x][next.y].x=head.x;
                        path[next.x][next.y].y=head.y;
                        path[next.x][next.y].step=mp[next.x][next.y]-'0';
                        Q.push(next);
                    }
                }
            }
            if(next.x==n-1&&next.y==m-1) ans=min(ans,next.step);
        }
    }
}
void output(int x,int y,int step)
{
    if(step==0) return ;
    step-=path[x][y].step;
    output(path[x][y].x,path[x][y].y,step-1);
    printf("%ds:(%d,%d)->(%d,%d)\n",step++,path[x][y].x,path[x][y].y,x,y);
    while(path[x][y].step--)printf("%ds:FIGHT AT (%d,%d)\n",step++,x,y);
}
void init()
{
    for(int i=0;i<110;i++)
        for(int j=0;j<110;j++)
            dist[i][j]=INF;
    memset(path,0,sizeof(path));
    ans=INF;
}
int main(void)
{
	while(scanf("%d%d",&n,&m)!=EOF)
    {
        init();
        for(int i=0;i<n;i++)
            scanf("%s",mp[i]);
        bfs();
        if(ans==INF) printf("God please help our poor hero.\nFINISH\n");
        else
        {
            printf("It takes %d seconds to reach the target position, let me show you the way.\n",ans);
            output(n-1,m-1,ans);
            printf("FINISH\n");
        }
    }
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值